<!-- NOTE: When updating the beneficiary details, make sure to also update the printable version. -->

<template>
  <div class="fr-container--fluid">
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12 fr-col-lg-6 beneficiary-details-col">
        <section class="beneficiary-details-section">
          <h2 class="fr-h6">Bénéficiaire</h2>
          <ul class="information-list">
            <li v-if="beneficiary.title">
              <span class="information-label">Civilité :</span>
              {{ TITLE_OPTIONS.get(beneficiary.title) }}
            </li>
            <li>
              <span class="information-label">Nom usuel :</span>
              {{ usualName }}
            </li>
            <li v-if="beneficiary.birth_name">
              <span class="information-label">Nom de naissance :</span>
              {{ beneficiary.birth_name }}
            </li>
            <li>
              <span class="information-label">Prénom(s) :</span>
              {{ nameOrEmpty(beneficiary.firstname) }}
            </li>
            <li v-if="beneficiary.birthdate">
              <span class="information-label">Date de naissance :</span>
              {{ formatDate(beneficiary.birthdate) }} ({{
                age(beneficiary.birthdate)
              }}
              ans)
            </li>
            <li v-if="beneficiary.birth_place">
              <span class="information-label">Ville de naissance :</span>
              {{ beneficiary.birth_place }}
            </li>
            <li v-if="beneficiary.deathdate">
              <span class="information-label">Date de décès :</span>
              {{ formatDate(beneficiary.deathdate) }}
            </li>
            <li v-if="beneficiary.gender">
              <span class="information-label">Genre :</span>
              {{ GENDER_OPTIONS.get(beneficiary.gender) }}
            </li>
            <li v-if="beneficiary.nationality">
              <span class="information-label">Nationalité :</span>
              {{ NATIONALITY_OPTIONS.get(beneficiary.nationality) }}
            </li>
            <li v-if="isMinistryAgent && beneficiary.numero_pegase">
              <span class="information-label">Numéro Pégase :</span>
              {{ beneficiary.numero_pegase }}
            </li>
            <li v-if="beneficiary.accommodation_mode">
              <span
                :class="{ 'information-line': beneficiary.accommodation_name }"
              >
                <span class="information-label">Hébergement :</span>
                {{
                  ACCOMMODATION_MODE_OPTIONS.get(beneficiary.accommodation_mode)
                }}
              </span>
              <span
                v-if="beneficiary.accommodation_name"
                class="information-line"
              >
                {{ beneficiary.accommodation_name }}
              </span>
            </li>
            <li v-if="isMinistryAgent && beneficiary.accommodation_zone">
              <span class="information-label">Zone d'hébergement :</span>
              {{
                ACCOMMODATION_ZONE_OPTIONS.get(beneficiary.accommodation_zone)
              }}
            </li>
            <li v-if="beneficiary.accommodation_additional_information">
              <span class="information-label">Précisions hébergement :</span>
              {{ beneficiary.accommodation_additional_information }}
            </li>
            <li v-if="hasAddress">
              <span class="information-label information-line">Adresse :</span>
              <span
                v-if="beneficiary.street"
                class="information-line"
              >
                {{ beneficiary.street_number }} {{ beneficiary.street }}
              </span>
              <span
                v-if="beneficiary.address_complement"
                class="information-line"
              >
                {{ beneficiary.address_complement }}
              </span>
              <span
                v-if="beneficiary.zip_code || beneficiary.city"
                class="information-line"
              >
                {{ beneficiary.zip_code }} {{ beneficiary.city }}
              </span>
              <span
                v-if="beneficiary.region"
                class="information-line"
              >
                {{ beneficiary.region }}
              </span>
            </li>
            <li
              v-if="beneficiary.no_phone"
              class="fr-icon-close-circle-line"
            >
              N'a pas de téléphone
            </li>
            <li v-if="!beneficiary.no_phone && beneficiary.phone_1">
              <span class="information-label">Téléphone :</span> {{ phone }}
            </li>
            <li v-if="beneficiary.email">
              <span class="information-label">Email :</span>
              {{ beneficiary.email }}
            </li>
            <li
              v-if="beneficiary.caregiver"
              class="fr-icon-success-line"
            >
              Aidant familial
            </li>
            <li v-if="beneficiary.mobility">
              <span class="information-label">Données mobilité :</span>
              {{ MOBILITY_MODE_OPTIONS.get(beneficiary.mobility) }}
            </li>
            <li v-if="beneficiary.administration">
              <span class="information-label">Administration :</span>
              {{ beneficiary.administration }}
            </li>
            <li v-if="beneficiary.minister">
              <span class="information-label">Ministre :</span>
              {{ beneficiary.minister }}
            </li>
          </ul>
        </section>
        <section
          v-if="hasHealthSection"
          class="beneficiary-details-section"
        >
          <h2 class="fr-h6">Santé</h2>
          <ul class="information-list">
            <li v-if="beneficiary.gir">
              <span class="information-label">GIR :</span>
              {{ girLabel(beneficiary.gir) }}
            </li>
            <li v-if="beneficiary.doctor">
              <span class="information-label">Médecin traitant :</span>
              {{ beneficiary.doctor }}
            </li>
            <li v-if="beneficiary.health_additional_information">
              <span class="information-label"
                >Informations complémentaires :</span
              >
              {{ beneficiary.health_additional_information }}
            </li>
            <li v-if="hasNirAccess && beneficiary.social_security_number">
              <span class="information-label">N° Sécurité Sociale :</span>
              {{ beneficiary.social_security_number }}
            </li>
            <li v-if="beneficiary.insurance">
              <span class="information-label">Mutuelle :</span>
              {{ beneficiary.insurance }}
            </li>
          </ul>
        </section>
        <section
          v-if="hasOccupationIncomeSection"
          class="beneficiary-details-section"
        >
          <h2 class="fr-h6">Activité/Revenu</h2>
          <ul class="information-list">
            <li v-if="beneficiary.socio_professional_category">
              <span class="information-label"
                >Catégorie socio-professionnelle :</span
              >
              {{
                SOCIO_PROFESSIONAL_CATEGORY_OPTIONS.get(
                  beneficiary.socio_professional_category
                )
              }}
            </li>
            <li v-if="beneficiary.occupation">
              <span class="information-label">Profession(s) :</span>
              {{ beneficiary.occupation }}
            </li>
            <li v-if="beneficiary.employer">
              <span class="information-label">Employeur :</span>
              {{ beneficiary.employer }}
            </li>
            <li v-if="beneficiary.employer_siret">
              <span class="information-label">SIRET de l'employeur :</span>
              {{ beneficiary.employer_siret }}
            </li>
            <li v-if="mainIncomeType">
              <span class="information-label">Nature des ressources :</span>
              {{ mainIncomeType }}
            </li>
            <li v-if="beneficiary.main_income_amount">
              <span class="information-label">Montant des ressources :</span>
              {{ euros(beneficiary.main_income_amount) }}
            </li>
            <li v-if="partnerMainIncomeType">
              <span class="information-label"
                >Nature des ressources du conjoint :</span
              >
              {{ partnerMainIncomeType }}
            </li>
            <li v-if="beneficiary.partner_main_income_amount">
              <span class="information-label"
                >Montant des ressources du conjoint :</span
              >
              {{ euros(beneficiary.partner_main_income_amount) }}
            </li>
            <li v-if="majorChildrenMainIncomeType">
              <span class="information-label"
                >Nature des ressources des enfants majeurs :</span
              >
              {{ majorChildrenMainIncomeType }}
            </li>
            <li v-if="beneficiary.major_children_main_income_amount">
              <span class="information-label"
                >Montant des ressources des enfants majeurs :</span
              >
              {{ euros(beneficiary.major_children_main_income_amount) }}
            </li>
            <li v-if="beneficiary.pole_emploi">
              <span class="information-label">N° Pôle Emploi :</span>
              {{ beneficiary.pole_emploi }}
            </li>
            <li v-if="pensionOrganisations">
              <span class="information-label">Organisme(s) de retraite :</span>
              {{ pensionOrganisations }}
            </li>
            <li v-if="beneficiary.caf">
              <span class="information-label">N° CAF :</span>
              {{ beneficiary.caf }}
            </li>
            <li v-if="beneficiary.bank">
              <span class="information-label">Banque :</span>
              {{ beneficiary.bank }}
            </li>
            <li v-if="beneficiary.funeral_contract">
              <span class="information-label">Contrat obsèques :</span>
              {{ beneficiary.funeral_contract }}
            </li>
            <template v-if="isMinistryAgent">
              <li v-if="beneficiary.ministere_categorie">
                <span class="information-label">Catégorie :</span>
                {{
                  MINISTERE_CATEGORIE_OPTIONS.get(
                    beneficiary.ministere_categorie
                  )
                }}
              </li>
              <li v-if="beneficiary.ministere_departement_service_ac">
                <span class="information-label"
                  >Département ou service de l'Administration Centrale :</span
                >
                {{
                  MINISTERE_DEPARTEMENT_SERVICE_AC_OPTIONS.get(
                    beneficiary.ministere_departement_service_ac
                  )
                }}
              </li>
              <li v-if="beneficiary.ministere_structure">
                <span class="information-label"
                  >Structure de rattachement :</span
                >
                {{
                  MINISTERE_STRUCTURE_OPTIONS.get(
                    beneficiary.ministere_structure
                  )
                }}
              </li>
            </template>
          </ul>
        </section>
        <BeneficiaryDetailsRelatives
          v-if="canAccessRelatives && houseHoldSection"
          class="beneficiary-details-section"
          :beneficiary="beneficiary"
          :relatives="householdRelatives"
          :pending="householdRelativesPending"
          :error="householdRelativesError"
          household
        />
        <BeneficiaryDetailsRelatives
          v-if="canAccessRelatives && relatives?.length"
          class="beneficiary-details-section"
          :relatives="relatives"
          :pending="relativesPending"
          :error="relativesError"
        />
      </div>
      <div class="fr-col-12 fr-col-lg-6 beneficiary-details-col">
        <section class="beneficiary-details-section fr-container--fluid">
          <h2 class="fr-h6">Types d'accompagnement</h2>
          <section class="fr-mb-1w">
            <h3 class="fr-text--lg fr-mb-0">Aides légales</h3>
            <ul
              v-if="legalFollowUpTypes.length"
              class="fr-grid-row fr-mt-1v beneficiary-details"
            >
              <li
                v-for="followUpType in legalFollowUpTypes"
                :key="followUpType.id"
                class="fr-icon-success-line fr-col-12 fr-col-md-6 follow-up-type"
              >
                {{ followUpType.name }}
              </li>
            </ul>
            <span
              v-else
              class="information-line"
            >
              Aucune
            </span>
          </section>
          <section>
            <h3 class="fr-text--lg fr-mb-0">Aides facultatives</h3>
            <ul
              v-if="optionalFollowUpTypes.length"
              class="fr-grid-row fr-mt-1v beneficiary-details"
            >
              <li
                v-for="followUpType in optionalFollowUpTypes"
                :key="followUpType.id"
                class="fr-icon-success-line fr-col-12 fr-col-md-6 follow-up-type"
              >
                {{ followUpType.name }}
              </li>
            </ul>
            <span
              v-else
              class="information-line"
            >
              Aucune
            </span>
          </section>
        </section>
        <section
          v-if="hasOtherInformationSection"
          class="beneficiary-details-section"
        >
          <h2 class="fr-h6">Autres informations</h2>
          <ul class="information-list">
            <li v-if="beneficiary.protection_measure">
              <span class="information-label">Mesure de protection :</span>
              {{
                PROTECTION_MEASURE_OPTIONS.get(beneficiary.protection_measure)
              }}
            </li>
            <li v-if="beneficiary.representative">
              <span class="information-label information-line">
                Nom, prénom, coordonées du mandataire :
              </span>
              <span class="information-line">
                {{ beneficiary.representative }}
              </span>
            </li>
            <li v-if="beneficiary.prescribing_organisation">
              <span class="information-label">Organisme prescripteur :</span>
              {{ beneficiary.prescribing_organisation }}
            </li>
            <li v-if="beneficiary.orientation_type">
              <span class="information-label">Mode d'orientation :</span>
              {{ ORIENTATION_TYPE_OPTIONS.get(beneficiary.orientation_type) }}
            </li>
            <li v-if="beneficiary.orientation_organisation">
              <span class="information-label">Organisme d'orientation :</span>
              {{ beneficiary.orientation_organisation }}
            </li>
            <li v-if="beneficiary.service_providers">
              <span class="information-label">Prestataires :</span>
              {{ beneficiary.service_providers }}
            </li>
            <li v-if="beneficiary.involved_partners">
              <span class="information-label">Partenaires intervenants :</span>
              {{ beneficiary.involved_partners }}
            </li>
            <li v-if="beneficiary.additional_information">
              <span class="information-label">
                Informations complémentaires :
              </span>
              {{ beneficiary.additional_information }}
            </li>
          </ul>
        </section>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
  import {
    TITLE_OPTIONS,
    GENDER_OPTIONS,
    ACCOMMODATION_MODE_OPTIONS,
    ACCOMMODATION_ZONE_OPTIONS,
    MOBILITY_MODE_OPTIONS,
    SOCIO_PROFESSIONAL_CATEGORY_OPTIONS,
    PROTECTION_MEASURE_OPTIONS,
    ORIENTATION_TYPE_OPTIONS,
    MINISTERE_STRUCTURE_OPTIONS,
    MINISTERE_DEPARTEMENT_SERVICE_AC_OPTIONS,
    MINISTERE_CATEGORIE_OPTIONS
  } from '~/utils/constants/beneficiary'
  import { NATIONALITY_OPTIONS } from '~/utils/constants/nationalities'
  import type { Beneficiary } from '~/types/beneficiary'
  import { formatDate, age, girLabel, euros } from '~/utils'
  import { getRandomId } from '~~/utils/random'
  import { usePermissionsStore } from '~/store/permissions'
  import { nameOrEmpty } from '~~/utils/beneficiary'
  import type { Relative } from '~/types/relative'

  const props = defineProps<{
    beneficiary: Beneficiary
  }>()

  const isMinistryAgent = useMinistryAgent()
  const permissionsStore = usePermissionsStore()

  const {
    usualName,
    hasAddress,
    hasHealthSection,
    hasOccupationIncomeSection,
    hasOtherInformationSection,
    legalFollowUpTypes,
    optionalFollowUpTypes,
    mainIncomeType,
    partnerMainIncomeType,
    majorChildrenMainIncomeType,
    pensionOrganisations,
    hasNirAccess,
    phone
  } = useBeneficiaryDetails(computed(() => props.beneficiary))

  const { $loadBeneficiaryRelatives, $loadBeneficiaryHouseholdRelatives } =
    useNuxtApp()

  const canAccessRelatives = computed(() => permissionsStore.canAccessRelatives)

  const {
    data: householdRelatives,
    pending: householdRelativesPending,
    error: householdRelativesError
  } = useLazyAsyncData<Relative[]>(
    getRandomId('householdRelatives'),
    loadHouseholdRelatives,
    { server: false, default: () => [] }
  )

  const {
    data: relatives,
    pending: relativesPending,
    error: relativesError
  } = useLazyAsyncData(getRandomId('relatives'), loadRelatives, {
    server: false,
    default: () => []
  })

  const houseHoldSection = computed(
    () =>
      householdRelatives.value?.length ||
      props.beneficiary.family_situation ||
      props.beneficiary.minor_children ||
      props.beneficiary.major_children
  )

  async function loadHouseholdRelatives() {
    if (!canAccessRelatives.value) return []
    return await $loadBeneficiaryHouseholdRelatives(props.beneficiary.id)
  }

  async function loadRelatives() {
    if (!canAccessRelatives.value) return []
    return await $loadBeneficiaryRelatives(props.beneficiary.id)
  }
</script>

<style lang="scss" scoped>
  @use '@gouvfr/dsfr/module/media-query' as dsfr-media-query;

  @include dsfr-media-query.respond-from('lg') {
    .beneficiary-details-col:nth-of-type(2) {
      border-left: 1px solid rgb(151 151 151 / 30%);
    }
  }

  .follow-up-type {
    display: inline-flex;
    word-break: break-word;

    &::before {
      font-size: 1rem;
      margin-right: 4px;
    }
  }

  .beneficiary-details-section {
    --title-spacing: 0 0 0.75rem;

    &:not(:last-child) {
      margin-bottom: 2rem;
    }
  }
</style>
